/**
 * apeman bud for ci scripts.
 * @memberof module:apeman-bud-ci/lib
 * @function setup
 * @param {object} params - Template params.
 * @returns {object} - Coz bud configuration.
 */

"use strict";

var argx = require('argx'),
    async = require('async'),
    stringcase = require('stringcase'),
    apemanfile = require('apemanfile'),
    fs = require('fs');

/** @lends setup */
function setup(params) {
    var args = argx(arguments);
    params = args.shift('object');
    return function bud(callback) {
        async.waterfall([
            function (callback) {
                apemanfile.load(params.configuration, callback);
            },
            function (apemanfile, callback) {
                var $tasks = apemanfile.$tasks || {};
                var bud = Object.keys($tasks).map(function (name) {
                    return {
                        force: false,
                        mode: '755',
                        mkdirp: true,
                        path: stringcase.snakecase(name.replace(/[#:\$\/]/g, '_')) + '.js',
                        tmpl: fs.readFileSync(__dirname + '/../asset/tmpl.hbs').toString(),
                        data: {
                            name: name,
                            params: params
                        }
                    };
                });
                callback(null, bud);
            }
        ], callback);
    };
}

module.exports = setup;
